#ifndef LOG_HH
# define LOG_HH

#include <ostream>
#include <fstream>

typedef std::string string;
typedef std::ostream ostream;
typedef std::ofstream ofstream;

class Logger {
public:
  Logger(ostream &o) : flux_(o) {}
  Logger(ostream &, const string &);
  ~Logger();

  bool file(const string &);
  bool has_file() const;

  friend Logger &operator<<(Logger &l, const string &s);
  friend Logger &operator<<(Logger &l, const char *s);
  friend Logger &operator<<(Logger &l, int i);

private:
  ostream &flux_;
  ofstream logfile_;

};

extern Logger logout;
extern Logger logerr;

#endif
